#include "mainwindow.h"
#include "ui_mainwindow.h"

using namespace std;

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);   

    bool bol = true;
    this->setMouseTracking(bol);
    ui->widget->setMouseTracking(bol);
    ui->widget_2->setMouseTracking(bol);
    qDebug() << this->hasMouseTracking() << endl;

    connect(ui->actionConectar, SIGNAL(triggered()),this, SLOT(conectar()));
    connect(ui->actionDesconectar, SIGNAL(triggered()),this, SLOT(desconectar()));
    connect(ui->pushButton_1, SIGNAL(clicked()),this, SLOT(enviar_cmd1()));
    connect(ui->pushButton_2, SIGNAL(clicked()),this, SLOT(enviar_cmd2()));
    connect(ui->pushButton_3, SIGNAL(clicked()),this, SLOT(enviar_cmd3()));
    connect(ui->pushButton_4, SIGNAL(clicked()),this, SLOT(enviar_cmd4()));
    connect(ui->pushButton_5, SIGNAL(clicked()),this, SLOT(enviar_cmd5()));
    connect(ui->pushButton_6, SIGNAL(clicked()),this, SLOT(enviar_cmd6()));
    connect(this,SIGNAL(forward()),this, SLOT(enviar_cdfor()));
    connect(this,SIGNAL(reverse()),this, SLOT(enviar_cdrev()));
    connect(ui->actionReset, SIGNAL(triggered()),this, SLOT(reset()));
    connect(ui->actionSalir,SIGNAL(triggered()), this,SLOT(exit()));



    ui->progressBar->setValue(0);


    QImage   Imagen;
    Imagen.load("images/flecha-derecha.png");
    ui->image2->setPixmap(QPixmap::fromImage(Imagen.scaled(64,64)));
    Imagen.load("images/flecha-izquierda.png");
    ui->image1->setPixmap(QPixmap::fromImage(Imagen.scaled(64,64)));    
    Imagen.load("images/LEGO_RCX_motor.png");
    ui->image_motor->setPixmap(QPixmap::fromImage(Imagen.scaled(161,111)));




    int pt[20];
    serial = new Controlador(this);
    serial->buscar_COM(&pt[0]);
    for(int i=0;i<20;i++){
        if(pt[i]==1){
            switch(i){
                case 0: {ui->Puertos->addItem("COM0");break;}
                case 1: {ui->Puertos->addItem("COM1");break;}
                case 2: {ui->Puertos->addItem("COM2");break;}
                case 3: {ui->Puertos->addItem("COM3");break;}
                case 4: {ui->Puertos->addItem("COM4");break;}
                case 5: {ui->Puertos->addItem("COM5");break;}
                case 6: {ui->Puertos->addItem("COM6");break;}
                case 7: {ui->Puertos->addItem("COM7");break;}
                case 8: {ui->Puertos->addItem("COM8");break;}
                case 9: {ui->Puertos->addItem("COM9");break;}
                case 10: {ui->Puertos->addItem("COM10");break;}
                case 11: {ui->Puertos->addItem("COM11");break;}
                case 12: {ui->Puertos->addItem("COM12");break;}
                case 13: {ui->Puertos->addItem("COM13");break;}
                case 14: {ui->Puertos->addItem("COM14");break;}
                case 15: {ui->Puertos->addItem("COM15");break;}
                case 16: {ui->Puertos->addItem("COM16");break;}
                case 17: {ui->Puertos->addItem("COM17");break;}
                case 18: {ui->Puertos->addItem("COM18");break;}
                case 19: {ui->Puertos->addItem("COM19");break;}
            }
          }
    }

}

MainWindow::~MainWindow()
{
    serial = NULL;
    delete ui;

}

void MainWindow::conectar(){

    if(serial->set == false)serial = new Controlador(this);
    serial->setCOM(ui->Puertos->currentText());
    serial->Conectar();

}

void MainWindow::desconectar(){
    if(serial->set != false){
        serial->port->close();
        serial->port == NULL;
        serial->set = false;
    }
}

void MainWindow::enviar_cmd1(){
    if (serial->set != false){
        serial->Enviar("1");
        ui->progressBar->setValue(5);
    }
}

void MainWindow::enviar_cmd2(){
    if (serial->set != false){
        serial->Enviar("2");
        ui->progressBar->setValue(15);
    }
}

void MainWindow::enviar_cmd3(){
    if (serial->set != false){
        serial->Enviar("3");
        ui->progressBar->setValue(35);
    }
}

void MainWindow::enviar_cmd4(){
    if (serial->set != false){
        serial->Enviar("4");
        ui->progressBar->setValue(50);
    }
}
void MainWindow::enviar_cmd5(){
    if (serial->set != false){
        serial->Enviar("5");
        ui->progressBar->setValue(65);
    }
}
void MainWindow::enviar_cmd6(){
    if (serial->set != false){
        serial->Enviar("6");
        ui->progressBar->setValue(80);
    }
}

void MainWindow::reset(){
    if (serial->set != false){
        delete serial;        
        serial = new Controlador(this);
        serial->Conectar();
    }
    else{
        serial = new Controlador(this);
        serial->Conectar();
    }
}

void MainWindow::enviar_cdfor(){
    if (serial->set != false){
        serial->Enviar("7");
        qDebug("Enviado forward");
    }
}
void MainWindow::enviar_cdrev(){
    if (serial->set != false){
        serial->Enviar("8");
        qDebug("Enviado reverse");
    }
}


void MainWindow::mouseMoveEvent(QMouseEvent *e){
    qDebug() << "x: "  << e->pos().x() << " y: "<< e->pos().y() << endl;

}
void MainWindow::mousePressEvent(QMouseEvent *e){
    qDebug() << "x: "  << e->globalX() << " y: "<< e->globalY()<< "boton: " << e->button() << endl;
    int y=e->globalY();
    int x=e->globalX();
    if(y>=330 && y<=368){
        if(x>=714 && x<=772){
            emit reverse();
        }
        else if(x>=804 && x<=862){
            emit forward();
        }
    }
}

void MainWindow::exit(){
    qDebug() << serial->set << "  " << serial->port;
    if(serial->set != false)delete serial;
    this->close();

}
